Index: trunk/sources/HeuristicLab.Problems.DataAnalysis.Regression/3.3/HeuristicLab.Problems.DataAnalysis.Regression-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis.Regression/3.3/HeuristicLab.Problems.DataAnalysis.Regression-3.3.csproj	(revision 3294)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis.Regression/3.3/HeuristicLab.Problems.DataAnalysis.Regression-3.3.csproj	(revision 3309)
@@ -125,4 +125,8 @@
       <Name>HeuristicLab.Core-3.3</Name>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Data.Views\3.3\HeuristicLab.Data.Views-3.3.csproj">
+      <Project>{72104A0B-90E7-42F3-9ABE-9BBBADD4B943}</Project>
+      <Name>HeuristicLab.Data.Views-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Data\3.3\HeuristicLab.Data-3.3.csproj">
       <Project>{BBAB9DF5-5EF3-4BA8-ADE9-B36E82114937}</Project>
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis.Regression/3.3/RegressionProblemData.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis.Regression/3.3/RegressionProblemData.cs	(revision 3294)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis.Regression/3.3/RegressionProblemData.cs	(revision 3309)
@@ -41,5 +41,13 @@
     public Dataset Dataset {
       get { return dataset; }
-      set { dataset = value; }
+      set {
+        if (dataset != value) {
+          if (value == null) throw new ArgumentNullException();
+          else {
+            dataset = value;
+            OnDatasetChanged(EventArgs.Empty);
+          }
+        }
+      }
     }
     private StringValue targetVariable;
@@ -123,4 +131,10 @@
       if (listeners != null) listeners(this, e);
     }
+
+    public event EventHandler DatasetChanged;
+    protected virtual void OnDatasetChanged(EventArgs e) {
+      EventHandler handler = DatasetChanged;
+      if (handler != null) handler(this, e);
+    }
     #endregion
 
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis.Regression/3.3/RegressionProblemDataView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis.Regression/3.3/RegressionProblemDataView.Designer.cs	(revision 3294)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis.Regression/3.3/RegressionProblemDataView.Designer.cs	(revision 3309)
@@ -47,10 +47,6 @@
     private void InitializeComponent() {
       this.importButton = new System.Windows.Forms.Button();
-      this.tabControl = new System.Windows.Forms.TabControl();
-      this.parametersTabPage = new System.Windows.Forms.TabPage();
-      this.parameterCollectionView = new HeuristicLab.Core.Views.ParameterCollectionView();
+      this.datasetView = new HeuristicLab.Data.Views.StringConvertibleMatrixView();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
-      this.tabControl.SuspendLayout();
-      this.parametersTabPage.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -77,49 +73,26 @@
       this.importButton.Click += new System.EventHandler(this.importButton_Click);
       // 
-      // tabControl
+      // datasetView
       // 
-      this.tabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+      this.datasetView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                   | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.tabControl.Controls.Add(this.parametersTabPage);
-      this.tabControl.Location = new System.Drawing.Point(0, 52);
-      this.tabControl.Name = "tabControl";
-      this.tabControl.SelectedIndex = 0;
-      this.tabControl.Size = new System.Drawing.Size(529, 341);
-      this.tabControl.TabIndex = 4;
+      this.datasetView.Caption = "StringConvertibleMatrix View";
+      this.datasetView.Content = null;
+      this.datasetView.Location = new System.Drawing.Point(0, 52);
+      this.datasetView.Name = "datasetView";
+      this.datasetView.Size = new System.Drawing.Size(526, 341);
+      this.datasetView.TabIndex = 6;
       // 
-      // parametersTabPage
-      // 
-      this.parametersTabPage.Controls.Add(this.parameterCollectionView);
-      this.parametersTabPage.Location = new System.Drawing.Point(4, 22);
-      this.parametersTabPage.Name = "parametersTabPage";
-      this.parametersTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.parametersTabPage.Size = new System.Drawing.Size(521, 315);
-      this.parametersTabPage.TabIndex = 0;
-      this.parametersTabPage.Text = "Parameters";
-      this.parametersTabPage.UseVisualStyleBackColor = true;
-      // 
-      // parameterCollectionView
-      // 
-      this.parameterCollectionView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.parameterCollectionView.Caption = "ParameterCollection";
-      this.parameterCollectionView.Content = null;
-      this.parameterCollectionView.Location = new System.Drawing.Point(6, 6);
-      this.parameterCollectionView.Name = "parameterCollectionView";
-      this.parameterCollectionView.Size = new System.Drawing.Size(509, 303);
-      this.parameterCollectionView.TabIndex = 0;
-      // 
-      // RegressionProblemView
+      // RegressionProblemDataView
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.tabControl);
       this.Controls.Add(this.importButton);
-      this.Name = "RegressionProblemView";
+      this.Controls.Add(this.datasetView);
+      this.Name = "RegressionProblemDataView";
       this.Size = new System.Drawing.Size(529, 422);
+      this.Controls.SetChildIndex(this.datasetView, 0);
       this.Controls.SetChildIndex(this.importButton, 0);
-      this.Controls.SetChildIndex(this.tabControl, 0);
       this.Controls.SetChildIndex(this.nameLabel, 0);
       this.Controls.SetChildIndex(this.descriptionLabel, 0);
@@ -127,6 +100,4 @@
       this.Controls.SetChildIndex(this.descriptionTextBox, 0);
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
-      this.tabControl.ResumeLayout(false);
-      this.parametersTabPage.ResumeLayout(false);
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -137,7 +108,5 @@
 
     private System.Windows.Forms.Button importButton;
-    private System.Windows.Forms.TabControl tabControl;
-    private System.Windows.Forms.TabPage parametersTabPage;
-    private HeuristicLab.Core.Views.ParameterCollectionView parameterCollectionView;
+    private HeuristicLab.Data.Views.StringConvertibleMatrixView datasetView;
 
   }
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis.Regression/3.3/RegressionProblemDataView.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis.Regression/3.3/RegressionProblemDataView.cs	(revision 3294)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis.Regression/3.3/RegressionProblemDataView.cs	(revision 3309)
@@ -46,9 +46,23 @@
     }
 
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      if (Content != null)
+        Content.DatasetChanged += new EventHandler(Content_DatasetChanged);
+    }
+
+    protected override void DeregisterContentEvents() {
+      base.DeregisterContentEvents();
+      if(Content != null)
+        Content.DatasetChanged -= new EventHandler(Content_DatasetChanged);
+    }
+
+    private void Content_DatasetChanged(object sender, EventArgs e) {
+      this.datasetView.Content = this.Content.Dataset;
+    }
+
     protected override void OnContentChanged() {
       base.OnContentChanged();
       if (Content == null) {
-        parameterCollectionView.Content = null;
-        parameterCollectionView.Enabled = false;
         importButton.Enabled = false;
       } else {