Index: unk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Interfaces/IFunction.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Interfaces/IFunction.cs	(revision 3338)
+++ 	(revision )
@@ -1,43 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Text;
-using HeuristicLab.Core;
-
-namespace HeuristicLab.Encodings.SymbolicExpressionTree {
-  public interface IFunction : IItem {
-    string Name { get; }
-    IFunctionTree GetTreeNode();
-    ICollection<IFunction> GetAllowedSubFunctions(int index);
-    void AddAllowedSubFunction(IFunction f, int index);
-    void RemoveAllowedSubFunction(IFunction f, int index);
-    bool IsAllowedSubFunction(IFunction f, int index);
-    int MinSubTrees { get; }
-    int MaxSubTrees { get; }
-    int MinTreeHeight { get; }
-    int MinTreeSize { get; }
-    double Tickets { get; }
-    IOperator Initializer { get; }
-    IOperator Manipulator { get; }
-  }
-}
Index: unk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Interfaces/IFunctionTree.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Interfaces/IFunctionTree.cs	(revision 3338)
+++ 	(revision )
@@ -1,41 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Text;
-using HeuristicLab.Core;
-
-namespace HeuristicLab.Encodings.SymbolicExpressionTree {
-  public interface IFunctionTree {
-    bool HasLocalParameters { get; }
-    IList<IFunctionTree> SubTrees { get; }
-    IFunction Function { get; }
-    IOperation CreateShakingOperation(IScope scope);
-    IOperation CreateInitOperation(IScope scope);
-    int GetSize();
-    int GetHeight();
-    void AddSubTree(IFunctionTree tree);
-    void InsertSubTree(int index, IFunctionTree tree);
-    void RemoveSubTree(int index);
-    string ToString();
-  }
-}
Index: unk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionGrammar.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionGrammar.cs	(revision 3338)
+++ 	(revision )
@@ -1,114 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using HeuristicLab.Core;
-using System.Xml;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-
-namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding {
-  [StorableClass]
-  [Item("SymbolicExpressionGrammar", "Represents a grammar that defines the syntax of symbolic expression trees.")]
-  public class SymbolicExpressionGrammar : Item, ISymbolicExpressionGrammar {
-    //private List<Symbol> symbols = new List<Symbol>();
-    //public IEnumerable<Symbol> Symbols {
-    //  get { return symbols; }
-    //}
-
-    // internal implementation of a symbol for the start symbol
-    private class EmptySymbol : Symbol {
-    }
-
-    private Dictionary<Symbol, Dictionary<int, IEnumerable<Symbol>>> allowedSymbols;
-
-    public SymbolicExpressionGrammar()
-      : base() {
-      startSymbol = new EmptySymbol();
-      allowedSymbols = new Dictionary<Symbol, Dictionary<int, IEnumerable<Symbol>>>();
-    }
-
-    //public void AddSymbol(Symbol symbol) {
-    //  if (!symbols.Contains(symbol)) {
-    //    symbols.Add(symbol);
-    //    symbol.ToStringChanged += new EventHandler(symbol_ToStringChanged);
-
-    //    OnToStringChanged();
-    //  }
-    //}
-
-    //public void RemoveSymbol(Symbol symbol) {
-    //  symbols.Remove(symbol);
-    //  symbol.ToStringChanged -= new EventHandler(symbol_ToStringChanged);
-
-    //  // remove the operator from the allowed sub-functions of all functions
-    //  foreach (Symbol f in Symbols) {
-    //    for (int i = 0; i < f.MaxSubTrees; i++) {
-    //      f.RemoveAllowedSubFunction(symbol, i);
-    //    }
-    //  }
-    //  OnToStringChanged();
-    //}
-
-    private void symbol_ToStringChanged(object sender, EventArgs e) {
-      OnToStringChanged();
-    }
-
-    #region ISymbolicExpressionGrammar Members
-
-    public Symbol startSymbol;
-    public Symbol StartSymbol {
-      get { return startSymbol; }
-    }
-
-    public IEnumerable<Symbol> AllowedSymbols(Symbol parent, int argumentIndex) {
-      return allowedSymbols[parent][argumentIndex];
-    }
-
-    public int MinimalExpressionLength(Symbol start) {
-      throw new NotImplementedException();
-    }
-
-    public int MaximalExpressionLength(Symbol start) {
-      throw new NotImplementedException();
-    }
-
-    public int MinimalExpressionDepth(Symbol start) {
-      throw new NotImplementedException();
-    }
-
-    public int MinSubTrees(Symbol start) {
-      throw new NotImplementedException();
-    }
-
-    public int MaxSubTrees(Symbol start) {
-      throw new NotImplementedException();
-    }
-
-    public bool IsValidExpression(SymbolicExpressionTree expression) {
-      throw new NotImplementedException();
-    }
-
-    #endregion
-  }
-}
Index: unk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/Prog.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/Prog.cs	(revision 3338)
+++ 	(revision )
@@ -1,25 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.GeneralSymbols {
-  public sealed class Prog : Symbol {
-  }
-}
Index: unk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/Values.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/Values.cs	(revision 3338)
+++ 	(revision )
@@ -1,37 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Core;
-namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.GeneralSymbols {
-  [StorableClass]
-  [Item("Values", "Symbol that represents combination of multiple output values.")]
-  public sealed class Values : Symbol {
-    public override bool CanChangeName {
-      get {
-        return false;
-      }
-    }
-    public override SymbolicExpressionTreeNode CreateTreeNode() {
-      return new ValuesTreeNode(this);
-    }
-  }
-}
Index: unk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/ValuesTreeNode.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/ValuesTreeNode.cs	(revision 3338)
+++ 	(revision )
@@ -1,63 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using System.Collections.Generic;
-namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.GeneralSymbols {
-  [StorableClass]
-  public sealed class ValuesTreeNode : SymbolicExpressionTreeNode {
-    private List<string> allowedFunctionsInBranch;
-    [Storable]
-    public IEnumerable<string> AllowedFunctionsInBranch {
-      get { return allowedFunctionsInBranch; }
-      set { allowedFunctionsInBranch = new List<string>(value); }
-    }
-
-    [Storable]
-    private Dictionary<string, int> numberOfArguments;
-
-    // copy constructor
-    private ValuesTreeNode(ValuesTreeNode original)
-      : base(original) {
-      allowedFunctionsInBranch = new List<string>(original.allowedFunctionsInBranch);
-      numberOfArguments = new Dictionary<string, int>(original.numberOfArguments);
-    }
-
-    public ValuesTreeNode(Values valuesSymbol)
-      : base(valuesSymbol) {
-      numberOfArguments = new Dictionary<string, int>();
-      allowedFunctionsInBranch = new List<string>();
-    }
-
-    public int GetNumberOfArguments(string functionName) {
-      return numberOfArguments[functionName];
-    }
-
-    public int SetNumberOfArguments(string functionName, int numberOfArguments) {
-      return this.numberOfArguments[functionName] = numberOfArguments;
-    }
-
-    public override object Clone() {
-      return new ValuesTreeNode(this);
-    }
-  }
-}